package net.sourceforge.jnhf.gui;

import java.awt.Color;

public class Palettes
{

	public static final Color DEFAULT_PALETTE[] = {
			new Color(0x808080),
			new Color(0xA63D00),
			new Color(0xB01200),
			new Color(0x960044),
			new Color(0x8C0074),
			new Color(0xD82800),
			new Color(0xA40000),
			new Color(0x7C0800),
			new Color(0x402C00),
			new Color(0x004510),
			new Color(0x004A05),
			new Color(0x003C14),
			new Color(0x183C5C),
			new Color(0x000000),
			new Color(0x050505),
			new Color(0x000000),
			new Color(0xC7C7C7),
			new Color(0xFF7700),
			new Color(0xFF5521),
			new Color(0xFA3782),
			new Color(0xB52FEB),
			new Color(0xE40058),
			new Color(0xD82800),
			new Color(0xC84C0C), // 14
			new Color(0x887000),
			new Color(0x008035),
			new Color(0x008F05),
			new Color(0x009038), // 18
			new Color(0x009400),
			new Color(0x212121),
			new Color(0x009038),
			new Color(0x090909), // 1C
			new Color(0xFFFFFF),
			new Color(0x3CBCFC),
			new Color(0x69A2FF),
			new Color(0x4088FC), // 20
			new Color(0xFF45F3),
			new Color(0xFF618B),
			new Color(0xFC7460),
			new Color(0xFF9C12), // 24
			new Color(0xFABC20),
			new Color(0x9FE30E),
			new Color(0xFC9838),
			new Color(0x0CF0A4), // 28
			new Color(0x05FBFF),
			new Color(0x5E5E5E),
			new Color(0x0D0D0D),
			new Color(0x0D0D0D), // 2C
			new Color(0xFCFCFC),
			new Color(0xA6FCFF),
			new Color(0xB3ECFF),
			new Color(0xDAABEB), // 30
			new Color(0xFFA8F9),
			new Color(0xFFABB3),
			new Color(0xFFD2B0),
			new Color(0xFFEFA6),
			new Color(0xFFF79C),
			new Color(0xD7E895),
			new Color(0xA6EDAF),
			new Color(0xA2F2DA),
			new Color(0x99FFFC),
			new Color(0xDDDDDD),
			new Color(0x111111),
			new Color(0x111111)
		};

	public static final Color[] FCEU_PAL_PALETTE = {

        new Color(0x1D<<2, 0x1D<<2, 0x1D<<2 ), /* Value 0 */
        new Color(0x09<<2, 0x06<<2, 0x23<<2 ),  /* Value 1 */
        new Color(0x00<<2, 0x00<<2, 0x2A<<2 ),  /* Value 2 */
        new Color(0x11<<2, 0x00<<2, 0x27<<2 ),  /* Value 3 */
        new Color(0x23<<2, 0x00<<2, 0x1D<<2 ),  /* Value 4 */
        new Color(0x2A<<2, 0x00<<2, 0x04<<2 ),  /* Value 5 */
        new Color(0x29<<2, 0x00<<2, 0x00<<2 ),  /* Value 6 */
        new Color(0x1F<<2, 0x02<<2, 0x00<<2 ),  /* Value 7 */
        new Color(0x10<<2, 0x0B<<2, 0x00<<2 ),  /* Value 8 */
        new Color(0x00<<2, 0x11<<2, 0x00<<2 ),  /* Value 9 */
        new Color(0x00<<2, 0x14<<2, 0x00<<2 ),  /* Value 10 */
        new Color(0x00<<2, 0x0F<<2, 0x05<<2 ),  /* Value 11 */
        new Color(0x06<<2, 0x0F<<2, 0x17<<2 ),  /* Value 12 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 13 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 14 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 15 */
        new Color(0x2F<<2, 0x2F<<2, 0x2F<<2 ),  /* Value 16 */
        new Color(0x00<<2, 0x1C<<2, 0x3B<<2 ),  /* Value 17 */
        new Color(0x08<<2, 0x0E<<2, 0x3B<<2 ),  /* Value 18 */
        new Color(0x20<<2, 0x00<<2, 0x3C<<2 ),  /* Value 19 */
        new Color(0x2F<<2, 0x00<<2, 0x2F<<2 ),  /* Value 20 */
        new Color(0x39<<2, 0x00<<2, 0x16<<2 ),  /* Value 21 */
        new Color(0x36<<2, 0x0A<<2, 0x00<<2 ),  /* Value 22 */
        new Color(0x32<<2, 0x13<<2, 0x03<<2 ),  /* Value 23 */
        new Color(0x22<<2, 0x1C<<2, 0x00<<2 ),  /* Value 24 */
        new Color(0x00<<2, 0x25<<2, 0x00<<2 ),  /* Value 25 */
        new Color(0x00<<2, 0x2A<<2, 0x00<<2 ),  /* Value 26 */
        new Color(0x00<<2, 0x24<<2, 0x0E<<2 ),  /* Value 27 */
        new Color(0x00<<2, 0x20<<2, 0x22<<2 ),  /* Value 28 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 29 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 30 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 31 */
        new Color(0x3F<<2, 0x3F<<2, 0x3F<<2 ),  /* Value 32 */
        new Color(0x0F<<2, 0x2F<<2, 0x3F<<2 ),  /* Value 33 */
        new Color(0x17<<2, 0x25<<2, 0x3F<<2 ),  /* Value 34 */
        new Color(0x10<<2, 0x22<<2, 0x3F<<2 ),  /* Value 35 */
        new Color(0x3D<<2, 0x1E<<2, 0x3F<<2 ),  /* Value 36 */
        new Color(0x3F<<2, 0x1D<<2, 0x2D<<2 ),  /* Value 37 */
        new Color(0x3F<<2, 0x1D<<2, 0x18<<2 ),  /* Value 38 */
        new Color(0x3F<<2, 0x26<<2, 0x0E<<2 ),  /* Value 39 */
        new Color(0x3C<<2, 0x2F<<2, 0x0F<<2 ),  /* Value 40 */
        new Color(0x20<<2, 0x34<<2, 0x04<<2 ),  /* Value 41 */
        new Color(0x13<<2, 0x37<<2, 0x12<<2 ),  /* Value 42 */
        new Color(0x16<<2, 0x3E<<2, 0x26<<2 ),  /* Value 43 */
        new Color(0x00<<2, 0x3A<<2, 0x36<<2 ),  /* Value 44 */
        new Color(0x1E<<2, 0x1E<<2, 0x1E<<2 ),  /* Value 45 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 46 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 47 */
        new Color(0x3F<<2, 0x3F<<2, 0x3F<<2 ),  /* Value 48 */
        new Color(0x2A<<2, 0x39<<2, 0x3F<<2 ),  /* Value 49 */
        new Color(0x31<<2, 0x35<<2, 0x3F<<2 ),  /* Value 50 */
        new Color(0x35<<2, 0x32<<2, 0x3F<<2 ),  /* Value 51 */
        new Color(0x3F<<2, 0x31<<2, 0x3F<<2 ),  /* Value 52 */
        new Color(0x3F<<2, 0x31<<2, 0x36<<2 ),  /* Value 53 */
        new Color(0x3F<<2, 0x2F<<2, 0x2C<<2 ),  /* Value 54 */
        new Color(0x3F<<2, 0x36<<2, 0x2A<<2 ),  /* Value 55 */
        new Color(0x3F<<2, 0x39<<2, 0x28<<2 ),  /* Value 56 */
        new Color(0x38<<2, 0x3F<<2, 0x28<<2 ),  /* Value 57 */
        new Color(0x2A<<2, 0x3C<<2, 0x2F<<2 ),  /* Value 58 */
        new Color(0x2C<<2, 0x3F<<2, 0x33<<2 ),  /* Value 59 */
        new Color(0x27<<2, 0x3F<<2, 0x3C<<2 ),  /* Value 60 */
        new Color(0x31<<2, 0x31<<2, 0x31<<2 ),  /* Value 61 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ),  /* Value 62 */
        new Color(0x00<<2, 0x00<<2, 0x00<<2 ) /* Value 63 */
	};
}
