package net.sourceforge.jnhf.reil.translators;

import java.util.List;

import net.sourceforge.jnhf.disassembler.Instruction;
import net.sourceforge.jnhf.helpers.FilledList;
import net.sourceforge.jnhf.helpers.IFilledList;
import net.sourceforge.jnhf.reil.OperandSize;
import net.sourceforge.jnhf.reil.ReilHelpers;
import net.sourceforge.jnhf.reil.ReilInstruction;
import net.sourceforge.jnhf.reil.StandardEnvironment;

public class PhaTranslator
{
	public static List<ReilInstruction> translate(final StandardEnvironment environment, final Instruction instruction)
	{
		final IFilledList<ReilInstruction> instructions = new FilledList<ReilInstruction>();

		final long baseOffset = instruction.getAddress() * 0x100;
		final long offset = baseOffset;

		instructions.add(ReilHelpers.createStm(baseOffset + instructions.size(), OperandSize.BYTE, "A", OperandSize.BYTE, "SP", instruction));
		instructions.addAll(StackTranslator.decrementStackPointer(baseOffset + instructions.size(), environment, instruction));

		return instructions;
	}
}
